module Parser where
import Data.Char
import Data.Maybe
type ParsResult token result = (result,[token])  
type Parser token result = [token] -> [ParsResult token result]

satisfy :: (t -> Bool) -> Parser t t
satisfy p  [] = []
satisfy p (x:xs)
 |p x = [(x,xs)]
 |otherwise = []

terminal :: Eq t => t ->  Parser t t
terminal t = satisfy ((==) t)

token t = terminal t   <<- (\x->[x])

epsilon ::  Parser t [t]
epsilon xs = [([],xs)]

infixl 9 >-
infixl 9 +-
infix  6 <<-
infixl 3 !|+
infixl 3 |+


(+-) :: Parser t r1 -> Parser t r2 -> Parser t (r1,r2)
(+-) p1 p2 = \xs -> [((r1,r2),ts2)| (r1,ts1)<-p1 xs, (r2,ts2)<-p2 ts1]

(|+) :: Parser t r -> Parser t r -> Parser t r
(|+) p1 p2 xs = p1 xs ++ p2 xs

(!|+) :: Parser t r -> Parser t r -> Parser t r
(!|+) p1 p2 xs 
  |null p1res =  p2 xs
  |otherwise = p1res
  where p1res = p1 xs

(<<-) :: Parser t r1 -> (r1 -> r2) -> Parser t r2
(<<-) p f = \xs ->  [(f result,rest) |(result,rest) <-  p xs] 

(>-)  p1 p2 = (p1 +- p2) <<- (\(x,xs) -> x++xs)
